"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inCategory = exports.inCategories = void 0;

const inCategory = (category, {
  includeSubCategories = false
} = {}) => post => {
  const {
    data = post
  } = post; // if there is no post.data, we assume we are working with data object

  const {
    category: postCategory = ''
  } = data;
  const shouldIncludeSub = includeSubCategories || category.endsWith('/*');
  const result = shouldIncludeSub ? postCategory.startsWith(category.replace('/*', '')) : postCategory === category;
  return result;
};

exports.inCategory = inCategory;

const inCategories = (categories = []) => post => {
  return categories.some(category => inCategory(category)(post));
};

exports.inCategories = inCategories;
//# sourceMappingURL=filters.js.map