"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.load = load;

var _plugins = require("../plugins");

var _cache = _interopRequireDefault(require("./cache"));

const cache = (0, _cache.default)();

const loadCache = async () => {
  (0, _plugins.subscribe)(posts => cache.set(posts));
  cache.set(await (0, _plugins.run)());
};
/**
 * Return all entries. If ids is provided return all entries matching __id.
 * @param {String | Array<String>} ids Optional.
 */


async function load(ids) {
  if (!cache.isValid()) {
    await loadCache();
  }

  const entries = cache.get();
  const entriesIds = [].concat(ids).filter(Boolean);

  if (entriesIds.length) {
    return entries.filter(({
      data: {
        __id
      }
    }) => entriesIds.includes(__id));
  }

  return entries;
}
//# sourceMappingURL=load.js.map