"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasRenderer = hasRenderer;
exports.resolvePlugin = resolvePlugin;

var _path = require("path");

var _fs = _interopRequireDefault(require("fs"));

const INTERNALS = {
  'nextein-plugin-source-fs': (0, _path.resolve)(__dirname, 'internals/source-filesystem'),
  'nextein-plugin-markdown': (0, _path.resolve)(__dirname, 'internals/markdown'),
  'nextein-plugin-filter-unpublished': (0, _path.resolve)(__dirname, 'internals/filter-unpublished'),
  'nextein-plugin-sort-by-date': (0, _path.resolve)(__dirname, 'internals/sort-by-date')
};

function isLocal(name) {
  return name.startsWith('.');
}

function resolvePlugin(name) {
  return INTERNALS[name] || (isLocal(name) ? (0, _path.resolve)(process.cwd(), name) : name);
}

function hasRenderer(resolvedPath) {
  return _fs.default.existsSync((0, _path.resolve)(resolvedPath, 'render.js'));
}
//# sourceMappingURL=resolver.js.map